#define	FORM	struct scr_form

struct scr_form
	{
	int	wid;	/* width in pixels */
	int hgh;	/* height in lines */
	int	pix;	/* bits/pixel */
	int siz;	/* array size in bytes */
	int row;	/* row size in bytes (with padding) */
	int	bgc;	/* background color */
	char *array;/* pixel storage */
	};

typedef struct {
	int x,y;
	} Point;

#define NFORMS	8			/* number of form entries */

#define	PSET				scr_action = 0
#define	PRESET				scr_action = 1
#define	XOR					scr_action = 2
#define	OR					scr_action = 3
#define	AND					scr_action = 4

#define beep()				tone(800, 5)	/* make ^G noise */

#define	BegEnd(x, y)		scr_arcBeg = (x), scr_arcEnd = (y)

#define	Burst(x)			scr_burst = (x)

#define	circle(x,y,r,c)		arc((x), (y), r, c, rad2ang(scr_arcBeg), rad2ang(scr_arcEnd))

#define	circleR(x,y,r,c)	circle((scr_lrx + (x)), (scr_lry + (y)), r, c)

#define color(p,c)			scr_color(p,c)

#define	csrlin()			scr_srow() + 1

#define	Fg(x)				scr_fg = (x)

#define	getR(x1,y1,x2,y2,f)	get(scr_lrx+(x1),scr_lry+(y1),scr_lrx+(x2),scr_lry+(y2),f)

#define	lineR(x1,y1,x2,y2,c) line(scr_lrx+(x1),scr_lry+(y1),scr_lrx+(x2),scr_lry+(y2),c)

#define	lineTo(x2,y2,c)		line(scr_lrx,scr_lry,x2,y2,c)

#define	lineToR(x2,y2,c)	line(scr_lrx,scr_lry,scr_lrx+(x2),scr_lry+(y2),c)

#define	moveTo(x1,y1)		scr_lrx=(x1), scr_lry=(y1)

#define	moveToR(x1,y1)		scr_lrx+=(x1), scr_lry+=(y1)

#define	point(x,y)			getPixel(x,y)

#define	pset(x,y,c)			setPixel(x, y, c)

#define	psetR(x,y,c)		setPixel(scr_lrx+(x), scr_lry+(y), c)

#define pos()				scr_scol() + 1

#define width(w)			scr_width(w)

extern int scr_lrx;				/* last referenced x */
extern int scr_lry;				/* last referenced y */
extern int scr_xdpi;			/* x dimension dots/inch */
extern int scr_ydpi;			/* y dimension dots/inch */
extern int scr_maxx;			/* maximum x dimension */
extern int scr_maxy;			/* maximum y dimension */
extern double scr_arcBeg;		/* arc begin angle */
extern double scr_arcEnd;		/* arc end angle */
extern char scr_mode;			/* Current screen mode */
extern char scr_attr;			/* current text attribute */
extern char scr_page;			/* current text page */
extern char scr_twidth;			/* text width -- 40 or 80 */
extern char scr_burst;			/* Color Burst enable/disable */
extern char scr_row;			/* current text row */
extern char scr_col;			/* current text col */
extern char scr_action;			/* scr_put action */
extern char scr_fg;				/* foreground color */
extern int scr_txtx;			/* current text x position */
extern int scr_txty;			/* current text y position */
extern unsigned scr_gpage;		/* current graphic page - hga */
extern int scr_cols;			/* current number of columns */
extern int scr_rows;			/* current number of rows */
extern char scr_mode;			/* current screen mode */
extern char scr_page;			/* current page */
extern char scr_attr;			/* current attributes for screen
								   7 is white letters on black */
extern char scr_window_top;		/* first line to scroll */
/*	variables needed by SEE. Not used here. */
extern char scr_scrollup;		/* zero if scrollup leaves top line alone */
extern char scr_scrolldown;		/* zero if scroll down supported */
